 
#ifndef BASE_H
#define BASE_H
 
#include "latcommon/Const.h"
#include "latcommon/Types.h"
#include <string>


namespace LatCommon {
 
class Base : public BMat {
public:

   Base (int d, int maxDim, NormType norm = L2NORM);


   Base (const Base &);


   ~Base ();


   Base & operator= (const Base &);

   
   void kill ();


   void swap (Base & b);


   void permute (int i, int j);


   int getDim () const   { return m_dim; }  

   
   void setDim (int d);


   int getMaxDim () const   { return m_maxDim; }  


   NormType getNorm () const   { return m_norm; }  


   void setNorm (NormType norm);


   bool isNegativeNorm (int i) const   { return m_negFlag[i]; }  


   void setNegativeNorm (bool flag);


   void setNegativeNorm (bool flag, int j)   { m_negFlag[j] = flag; } 


   NScal getVecNorm (int i) const   { return m_vecNorm[i]; }  


   void setVecNorm (NScal & value, int i);


   void updateVecNorm (); 


   void updateVecNorm (int d); 


   void updateScalL2Norm (int d); 


   void updateScalL2Norm (int d1, int d2); 


   std::string toString () const;


   std::string toString (int i) const;

   
   void write () const;

 
   void write (int i) const;



protected:

   int m_dim;


   int m_maxDim;


   NormType m_norm;


   NVect m_vecNorm;


   bool* m_negFlag;     

};

}
 
#endif
 

