 
#ifndef CONST_H
#define CONST_H
 
#include <string>


namespace LatCommon {


enum NormType { SUPNORM, L1NORM, L2NORM, ZAREMBANORM };



enum GenType { LCG, MRG, MWC, KOROBOV, RANK1 };


   
enum LatticeType { FULL, RECURRENT, ORBIT, PRIMEPOWER };


          
enum PrimeType { UNKNOWN, PRIME, PROB_PRIME, COMPOSITE };


          
enum DecompType { DECOMP, DECOMP_WRITE, DECOMP_READ, DECOMP_PRIME };



enum OutputType { TERMINAL, RES, TEX, GEN };



enum CriterionType { SPECTRAL, BEYER, PALPHA, BOUND_JS };



enum NormaType { BESTLAT, LAMINATED, ROGERS, MINKOWSKI, MINKL1,
                 PALPHA_N, NORMA_GENERIC };



enum CalcType { PAL, NORMPAL, BAL, SEEKPAL };



enum ImplemCond { NO_COND, APP_FACT, POWER_TWO, EQUAL_COEF, ZERO_COEF };



enum SearchMethod { EXHAUST, RANDOM };


std::string toStringNorm (NormType);
std::string toStringGen (GenType);
std::string toStringLattice (LatticeType);
std::string toStringPrime (PrimeType);
std::string toStringDecomp (DecompType);
std::string toStringOutput (OutputType);
std::string toStringCriterion (CriterionType);
std::string toStringNorma (NormaType);
std::string toStringCalc (CalcType);
std::string toStringImplemCond (ImplemCond);
std::string toStringSearchMethod (SearchMethod);


}
 
#endif
 

