 
#ifndef KOROBOVLATTICE_H
#define KOROBOVLATTICE_H
 
#include "latcommon/Types.h"
#include "latcommon/Const.h"
#include "latcommon/IntLattice.h"


namespace LatCommon {

class KorobovLattice: public IntLattice {
public:

   KorobovLattice (const MScal & n, const MScal & a, int maxDim,
                   NormType norm = L2NORM);


   KorobovLattice (const MScal & n, const MScal & a, int dim, int t,
                   NormType norm = L2NORM);


   KorobovLattice (const KorobovLattice & Lat);


   KorobovLattice & operator= (const KorobovLattice & Lat);


   ~KorobovLattice();


   std::string toStringCoef() const;


   void buildBasis (int d);


   void incDim();


   void incDimSlow();



protected:

   MScal m_a;


   int m_shift;


   void init();


};

}
 
#endif
 

