  
/* NormaMinkowski.h for ISO C++ */
#ifndef NORMAMINKOWSKI_H
#define NORMAMINKOWSKI_H
 
#include "latcommon/Normalizer.h"
#include <stdexcept>


namespace LatCommon {

class NormaMinkowski : public Normalizer {
public:

   NormaMinkowski (const MScal & m, int k, int t, double beta = 1);


   double getGamma (int j) const throw (std::out_of_range);



private:

   static const double m_gamma[1 + Normalizer::MAX_DIM];


};

}
 
#endif
 

