 
/* Normalizer.h for ISO C++ */
#ifndef NORMALIZER_H
#define NORMALIZER_H
  
#include "latcommon/Types.h"
#include "latcommon/UtilLC.h"
#include "latcommon/Const.h"
#include <string>


namespace LatCommon {
          
class Normalizer {
public:

   static const int MAX_DIM = 48;

   Normalizer (const MScal & m, int k, int t, std::string Name,
               NormType norm = L2NORM, double beta = 1);


   virtual ~Normalizer ()   { delete [] m_cst; }   


   void init (const MScal & m, int k, double beta);


   std::string ToString () const;


   NormType getNorm () const   { return m_norm; }  


   void setNorm (NormType norm)   { m_norm = norm; }  


   int getDim () const   { return m_maxDim; }   


   double & getCst (int j);


   virtual double getGamma (int j) const;



protected:

   std::string m_name;


   NormType m_norm;


   MScal m_m;


   int m_rank;


   int m_maxDim;


   double m_beta;


   double *m_cst;



private:

   Normalizer (const Normalizer &);
   Normalizer & operator= (const Normalizer &);


};

}

 
#endif
 

