 
#ifndef RANK1LATTICE_H
#define RANK1LATTICE_H
 
#include "latcommon/Types.h"
#include "latcommon/Const.h"
#include "latcommon/IntLattice.h"


namespace LatCommon {

class Rank1Lattice: public IntLattice {
public:

   Rank1Lattice (const MScal & n, const MVect & a, int d,
                 NormType norm = L2NORM);


   Rank1Lattice (const Rank1Lattice & Lat);


   Rank1Lattice & operator= (const Rank1Lattice & Lat);


   ~Rank1Lattice();


   std::string toStringCoef() const;


   void buildBasis (int d);


   void incDim ();



protected:

   void init();


   MVect m_a;

};

}
 
#endif
 

